Package org.eclipse.ui.handlers

## Class RadioState

- java.lang.Object
- - org.eclipse.core.commands.common.EventManager
  - - org.eclipse.core.commands.State
    - - org.eclipse.jface.commands.PersistentState
      - - org.eclipse.ui.handlers.RadioState

All Implemented Interfaces:
  `IExecutableExtension`

    public final class RadioState
    extends PersistentState
    implements IExecutableExtension

This state supports a radio-button like command, where the value of the parameterized command is stored as state. The command must define a state using the `STATE_ID` id and a string commandParameter using the `PARAMETER_ID` id. Menu contributions supplied by `org.eclipse.ui.menus` can then set the `PARAMETER_ID`.

When parsing from the registry, this state understands two parameters: `default`, which is the default value for this item; and `persisted`, which is whether the state should be persisted between sessions. The `default` parameter has no default value and must be specified in one of its forms, and the `persisted` parameter defaults to `true`. If only one parameter is passed (i.e., using the class name followed by a colon), then it is assumed to be the `default` parameter.

Since:
  3.5
See Also:
  `HandlerUtil.updateRadioState(org.eclipse.core.commands.Command, String)`, `HandlerUtil.matchesRadioState(org.eclipse.core.commands.ExecutionEvent)`

### Field Summary

Fields
`static String` `PARAMETER_ID` The parameter ID for a radio state understood by the system.
`static String` `STATE_ID` The state ID for a radio state understood by the system.

### Constructor Summary

Constructors
`RadioState()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `load​(IPreferenceStore store, String preferenceKey)` Loads this state from the preference store, given the location at which to look.
`void` `save​(IPreferenceStore store, String preferenceKey)` Saves this state to the preference store, given the location at which to write.
`void` `setInitializationData​(IConfigurationElement config, String propertyName, Object data)` This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information.
`void` `setValue​(Object value)` Sets the value for this state object.

### Methods inherited from class org.eclipse.jface.commands.PersistentState

`setShouldPersist, shouldPersist`

### Methods inherited from class org.eclipse.core.commands.State

`addListener, dispose, fireStateChanged, getId, getValue, removeListener, setId`

### Methods inherited from class org.eclipse.core.commands.common.EventManager

`addListenerObject, clearListeners, getListeners, isListenerAttached, removeListenerObject`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### STATE_ID

    public static final String STATE_ID

The state ID for a radio state understood by the system.

See Also:
  Constant Field Values

#### PARAMETER_ID

    public static final String PARAMETER_ID

The parameter ID for a radio state understood by the system.

See Also:
  Constant Field Values

### Constructor Detail

#### RadioState

    public RadioState()

### Method Detail

#### setInitializationData

    public void setInitializationData​(IConfigurationElement config,
                                      String propertyName,
                                      Object data)

Description copied from interface: `IExecutableExtension`
This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information. Most executable extensions only make use of the first two call arguments.

Regular executable extensions specify their Java implementation class name as an attribute of the configuration element for the extension. For example

         <action run="com.example.BaseAction"/>

In the above example, this method would be called with a reference to the `<action>` element (first argument), and `"run"` as the name of the attribute that defined this executable extension (second argument).

The last parameter is for the specific use of extension adapters and is typically not used by regular executable extensions.

There are two supported ways of associating additional adapter-specific data with the configuration in a way that is transparent to the extension point implementor:

(1) by specifying adapter data as part of the implementation class attribute value. The Java class name can be followed by a ":" separator, followed by any adapter data in string form. For example, if the extension point specifies an attribute `"run"` to contain the name of the extension implementation, an adapter can be configured as

         <action run="com.example.ExternalAdapter:./cmds/util.exe -opt 3"/>

(2) by converting the attribute used to specify the executable extension to a child element of the original configuration element, and specifying the adapter data in the form of xml markup. Using this form, the example above would become

         <action>
             <run class="com.xyz.ExternalAdapter">
                 <parameter name="exec" value="./cmds/util.exe"/>
                 <parameter name="opt"  value="3"/>
             </run>
         </action>

Form (2) will typically only be used for extension points that anticipate the majority of extensions configured into it will in fact be in the form of adapters.

In either case, the specified adapter class is instantiated using its 0-argument public constructor. The adapter data is passed as the last argument of this method. The data argument is defined as Object. It can have the following values:

- `null`, if no adapter data was supplied
- in case (1), the initialization data string is passed as a `String`
- in case (2), the initialization data is passed as a `Hashtable` containing the actual parameter names and values (both `String`s)

Specified by:
  `setInitializationData` in interface `IExecutableExtension`
Parameters:
  `config` - the configuration element used to trigger this execution. It can be queried by the executable extension for specific configuration properties
  `propertyName` - the name of an attribute of the configuration element used on the `createExecutableExtension(String)` call. This argument can be used in the cases where a single configuration element is used to define multiple executable extensions.
  `data` - adapter data in the form of a `String`, a `Hashtable`, or `null`.
See Also:
  `IConfigurationElement.createExecutableExtension(String)`

#### load

    public void load​(IPreferenceStore store,
                     String preferenceKey)

Description copied from class: `PersistentState`
Loads this state from the preference store, given the location at which to look. This method must be symmetric with a call to `PersistentState.save(IPreferenceStore, String)`.

Specified by:
  `load` in class `PersistentState`
Parameters:
  `store` - The store from which to read; must not be `null`.
  `preferenceKey` - The key at which the state is stored; must not be `null`.

#### save

    public void save​(IPreferenceStore store,
                     String preferenceKey)

Description copied from class: `PersistentState`
Saves this state to the preference store, given the location at which to write. This method must be symmetric with a call to `PersistentState.load(IPreferenceStore, String)`.

Specified by:
  `save` in class `PersistentState`
Parameters:
  `store` - The store to which the state should be written; must not be `null`.
  `preferenceKey` - The key at which the state should be stored; must not be `null`.

#### setValue

    public void setValue​(Object value)

Description copied from class: `State`
Sets the value for this state object.

Overrides:
  `setValue` in class `State`
Parameters:
  `value` - The value to set; may be anything.